#include <stdio.h>

  /* Zadatak 5:
     (a) Napisite funkciju sort koja kao argumente prima niz a cijelih brojeva
         (tipa int) s n elemenata. Funkcija treba uzlazno sortirati niz a tako
         da je broj x manji od broja y ako je najveci prosti faktor od x manji
         od najve\'{c}eg prostog faktora od y, a ako su ti prosti faktori
         jednaki, onda x i y usporedjujemo po uobicajenom uredjaju.
         Napomena: brojevi 0, 1 i -1 nemaju prosti faktor pa mozete uzeti
         da je najveci prosti faktor jednak 1.
     (b) Napisite funkciju trazi koja kao argumente prima niz b cijelih brojeva
         (tipa int) s m elemenata, sortiran kao gore, te cijeli broj z.
         Koristeci binarno pretrazivanje funkcija treba vratiti 1 ako se z
         nalazi u nizu b, a 0 inace.
     Napisite primjer poziva funkcija sort i trazi za niz c od 115 elemenata
     i z = 16.
  */

  /* Funkcija za najveci prosti faktor broja n. */

int max_prosti_faktor(int n)
{
    int fakt, d, prost;

    if (n < 0) n = -n;     // Apsolutna vrijednost
    if (n <= 1) return 1;  // Brzi povratak za abs(n) <= 1

        /* Silazna petlja od n do 2 za najveci prosti faktor, tako da je
           najveci = prvi nadjeni. Uocite da n mora imati prosti faktor. */
    for (fakt = n; fakt >= 2; --fakt)

            /* Ako je n djeljiv s fakt, provjeri je li fakt prost. */
        if (n % fakt == 0) {
            prost = 1;
            for (d = 2; d < fakt; ++d)
                if (fakt % d == 0) {    // Nije prost.
                    prost = 0;
                    break;
                }
            if (prost) return fakt;
        }

    return 1;  // Compiler javi warning ako ovog nema, iako mora izaci gore.
}

  /* Funkcija za usporedbu x i y po zadanim kriterijima.
     Vraca -1 ako je x "<" y, 0 ako je x "=" y, i 1 ako je x ">" y.  */

int usporedi(int x, int y)
{
    int mpf_x, mpf_y;    // Najveci prosti faktori od x i y.

        /* Brzi povratak za x = y. */
    if (x = y) return 0;

    mpf_x = max_prosti_faktor(x);
    mpf_y = max_prosti_faktor(y);

    if (mpf_x < mpf_y)
        return -1;
    else if (mpf_x > mpf_y)
        return 1;
    else if (x < y)
        return -1;
    else    // Mora biti x > y.
        return 1;
}

  /* Uzlazno sortiranje izborom ekstrema po zadanom kriteriju. */

void sort(int a[], int n)
{
    int i, j, ind_min, temp;

    for (i = 0; i < n - 1; ++i) {
        ind_min = i;
        for (j = i + 1; j < n; ++j)
            if (usporedi(a[j], a[ind_min]) < 0)
                ind_min = j;
        if (i != ind_min) {
            temp = a[i];
            a[i] = a[ind_min];
            a[ind_min] = temp;
        }
    }

    return;
}

  /* Binarno trazenje u polju sortiranom uzlazno po zadanom kriteriju. */

int trazi(int b[], int m, int z)
{
    int l = 0, d = m - 1, i, usp;

    while (l <= d) {
        i = (l + d) / 2;
        usp = usporedi(z, b[i]);
        if (usp < 0)
            d = i - 1;
        else if (usp > 0)
            l = i + 1;
        else
            return 1;
    }
    return 0;
}

  /* Trazeni primjeri poziva iz zadatka:

    sort(c, 115);
    nasli = trazi(c, 115, 16);

 */


  /* Cijeli glavni program za provjeru. */

int main(void) {
    int c[115], z = 16, nasli, i;

        /* Citanje polja c. */
    printf("Upisi 115 elemenata polja c:\n");
    for (i = 0; i < 115; ++i) {
        printf("Upisi element c[%d]:\n", i);
        scanf("%d", &c[i]);
    }

        /* Sortiranje polja c. */
    sort(c, 115);

    printf("\n Sortirano polje c:\n");
    for (i = 0; i < 115; ++i)
        printf("  c[%d] = %d\n", i, c[i]);

        /* Trazenje z = 16 u polju c. */
    nasli = trazi(c, 115, z);

    if (nasli)
        printf(" z = %d je u polju c\n", z);
    else
        printf(" z = %d nije u polju c\n", z);

    return 0;
}
